#ifndef bqtQBlibExecHH
#define bqtQBlibExecHH

#include <qblib/types.hh>

extern "C" {

void B_StmtSYSTEM(int code = 0) __attribute__((noreturn));
void B_StmtEND(int code = 0)    __attribute__((noreturn));
void B_StmtSTOP();

const std::string& B_FuncCOMMAND_S();

void B_CLEAR(int ds_size, int, int ss_size, bool in_sub);

void B_LibInit(int argc, char** argv);
void B_LibDone();

void B_DummyLoop(unsigned long n_iterations);

const BAS_STR B_FuncVARPTR_S(int typetag, unsigned long offs);

long double VARPTR_ReadNum(const char* s);
const BAS_STR& VARPTR_ReadStr(const char* s);

}

template<typename T>
static inline int B_FuncVARSEG(const T& t)
    { return 0; }

template<typename T>
static inline unsigned long B_FuncVARPTR(const T& t)
    { return reinterpret_cast<unsigned long>(&t); }

#define VARPTR_LENGTH (1 + (sizeof(unsigned long)))

#define VARPTR_TAG_BYTE 1
#define VARPTR_TAG_UBYTE 129
static inline const BAS_STR B_FuncVARPTR_S(const BAS_BYTE& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_BYTE, B_FuncVARPTR(s)); }
static inline const BAS_STR B_FuncVARPTR_S(const BAS_UBYTE& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_UBYTE, B_FuncVARPTR(s)); }

#define VARPTR_TAG_INT 2
#define VARPTR_TAG_UINT 130
static inline const BAS_STR B_FuncVARPTR_S(const BAS_INT& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_INT, B_FuncVARPTR(s)); }
static inline const BAS_STR B_FuncVARPTR_S(const BAS_UINT& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_UINT, B_FuncVARPTR(s)); }

#define VARPTR_TAG_SGN 4
static inline const BAS_STR B_FuncVARPTR_S(const BAS_SGN& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_SGN, B_FuncVARPTR(s)); }

#define VARPTR_TAG_DBL 8
static inline const BAS_STR B_FuncVARPTR_S(const BAS_DBL& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_DBL, B_FuncVARPTR(s)); }

#define VARPTR_TAG_LNG 20
#define VARPTR_TAG_ULONG 148
static inline const BAS_STR B_FuncVARPTR_S(const BAS_LNG& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_LNG, B_FuncVARPTR(s)); }
static inline const BAS_STR B_FuncVARPTR_S(const BAS_ULONG& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_ULONG, B_FuncVARPTR(s)); }

#define VARPTR_TAG_STR 3
static inline const BAS_STR B_FuncVARPTR_S(const BAS_STR& s)
  { return B_FuncVARPTR_S(VARPTR_TAG_STR, B_FuncVARPTR(s)); }

/* QB64 uses INT64=5, FLOAT=6, BIT=64+n , but for now we don't support them */

#endif
