#ifndef bqtQBlibGraphicsHH
#define bqtQBlibGraphicsHH

#include <cstdio> // for size_t

#include <qblib/string.hh>

/* Text */

void B_StmtVIEWPRINT(int from=-1, int to=-1);
int B_FuncSCREEN(int y,int x, int colorflag=0);
void B_ScreenPOKE(int x,int y, int colorflag, int value);

void B_StmtCLS(int type);
void B_StmtWIDTH(int w,int h);
void B_StmtCOLOR(int fg,int bg=-1,int border=-1);
void B_StmtLOCATE(int row,int col,int c_vis,int c_start,int c_stop=-1);
void B_StmtLOCATE(int row,int col,int c_vis);
void B_StmtLOCATE(int row,int col=-1);
static inline void B_StmtLOCATE() {} // without parameters, it does nothing

int B_FuncCSRLIN();
int B_FuncPOS(int=0);
int B_FuncWIDTH();

void GFX_OutS(const char* buffer, size_t nbytes);

/* System */

void GFX_Init();
void GFX_Done();

/* Misc */

const BAS_STR B_FuncINKEY_S(bool wait = false); // in gfx_term.cc
void B_StmtSLEEP(double duration = -1.0); // in gfx_term.cc
void B_StmtSCREEN(int mode,int color=-1,int apage=-1,int vpage=-1);

bool B_Funcqb64KEYDOWN(int keycode);

/* Graphics */

/* Note: Coordinates are passed as double, because the WINDOW
 * statement can be used to scale the pixels.
 */
void B_StmtPALETTE(int index, int value);

void B_StmtLINE(bool step1, double x1,double y1,
                bool step2, double x2,double y2,
                int color=-1, int fill=-1, int style=-1);

void B_StmtCIRCLE(bool step, double x,double y, double radius, int color=-1, double start=-1, double end=-1, double aspect=-1);

void B_StmtPSET(bool step, double x,double y, int color=-1);
void B_StmtPRESET(bool step, double x,double y, int color=-1);
int B_FuncPOINT(double x,double y);
int B_FuncPOINT(int whattoreport);

void B_StmtPAINT(bool step, double x,double y, int paint=-1,         int border=-1);
void B_StmtPAINT(bool step, double x,double y, const BAS_STR& paint, int border=-1, const BAS_STR& background = "");

template<typename Data>
void B_StmtPALETTE_USING(Data& data);

template<typename Data>
void B_StmtPUT(bool step, double x,double y, Data& data, int putstyle=-1);

template<typename Data>
void B_StmtGET(bool step1, double x1,double y1,
               bool step2, double x2,double y2, Data& data);

void B_StmtDRAW(const BAS_STR& commands);

void B_StmtWINDOW(bool screen, double x1,double y1, double x2,double y2);
void B_StmtWINDOW();

void B_RerenderTextScreen();

int B_Funcqb64NEWIMAGE(int width, int height, int bpp=0);
void B_Stmtqb64DONTBLEND(int screen_number=-1);

#include "gfx.tcc"


#endif
