#include <vector>

/* NOTE: This relies on a GNU extension.
 *
 * There is a way to do this with switch-cases, but there would be restrictions:
 *     - You could not nest switch-cases.
 */

extern std::vector<void*> GosubStack;

void B_GOSUB_Push(void* label);
void* B_GOSUB_Pop();

#define B_GOSUB_ptr(ptr) \
    { __label__ gosub_return; B_GOSUB_Push(&&gosub_return); \
      goto* ptr; gosub_return:; }

#define B_GOSUB(label) \
    { __label__ gosub_return; B_GOSUB_Push(&&gosub_return); \
      goto label; gosub_return:; }

#define B_RETURN()         { goto* (B_GOSUB_Pop());     }
#define B_RETURN_TO(label) { B_GOSUB_Pop(); goto label; }
