#ifndef bqtQBlibStringHH
#define bqtQBlibStringHH

#include <string>

class BAS_STR: public std::string
{
    // begin is zero-based here.
  //  void SetMid(long begin, long len, const BAS_STR& ref);
  //  void SetMid(long begin, const BAS_STR& ref);

public:
    BAS_STR() : std::string() { }

    BAS_STR(const char* p) : std::string(p) { }

    BAS_STR(const std::string& p) : std::string(p) { }
    BAS_STR(std::string&& p) : std::string(std::move(p)) { }

    BAS_STR(const BAS_STR& p) : std::string(p) { }
    BAS_STR(BAS_STR&& p) : std::string( std::move(p) ) { }

    BAS_STR(std::size_t n, char c) : std::string(n, c) { }

    inline BAS_STR& operator= (const BAS_STR& s) { std::string::operator=(s); return *this; }
    inline BAS_STR& operator= (BAS_STR&& s) { std::string::operator=( std::move(s) ); return *this; }

    inline BAS_STR& operator= (const std::string& s) { std::string::operator=(s); return *this; }
    inline BAS_STR& operator= (std::string&& s) { std::string::operator=( std::move(s) ); return *this; }

    inline BAS_STR& operator= (const char* s) { std::string::operator=(s); return *this; }

    inline BAS_STR& operator+= (const BAS_STR& s) { std::string::operator+=(s); return *this; }
    inline BAS_STR& operator+= (BAS_STR&& s) { std::string::operator+=( std::move(s) ); return *this; }

    inline BAS_STR& operator+= (const std::string& s) { std::string::operator+=(s); return *this; }
    inline BAS_STR& operator+= (std::string&& s) { std::string::operator+=( std::move(s) ); return *this; }

    inline BAS_STR& operator+= (const char* s) { std::string::operator+=(s); return *this; }
    inline BAS_STR& operator+= (char s) { std::string::operator+=(s); return *this; }
};

#endif
